# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define oname jboss-aop
%define namedversion 2.1.1.GA

%define without_coreonly 0
%define with_coreonly 1

%define without_jrockit 1
%define with_jrockit 0

Name:           jboss-aop2
Version:        2.1.1
Release:        1%{?dist}
Epoch:          0
Summary:        JBoss AOP
License:        LGPL
Group:          Development/Java
URL:            http://www.jboss.org/
Source0:        jboss-aop-2.1.1.tar.gz
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/aop/tags/JBoss_AOP_2_1_1_GA/ jboss-aop-2.1.1

Source1:        jboss-aop-jpp-depmap.xml
Source2:        jboss-aop-settings.xml
Source3:        http://repository.jboss.org/maven2/org/jboss/jboss-parent/4/jboss-parent-4.pom
Patch0:         jboss-aop-pom.patch
Patch1:         jboss-aop2-SystemOutLoggerPlugin.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-shared-enforcer-rule-api
BuildRequires:  maven-shared-plugin-testing-harness
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-report-maven-plugin
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  ant >= 0:1.7.0
BuildRequires:  gnu-trove
BuildRequires:  jarjar
BuildRequires:  jboss-profiler
BuildRequires:  jboss-test
BuildRequires:  junit44
BuildRequires:  qdox

BuildRequires:  bsh
BuildRequires:  concurrent
BuildRequires:  dom4j
BuildRequires:  javacc
BuildRequires:  javassist
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-log4j
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-man
BuildRequires:  jboss-mdr
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-reflect
BuildRequires:  jboss-vfs2
BuildRequires:  j2ee_connector_1_5_api
BuildRequires:  log4j
BuildRequires:  servlet_2_5_api
BuildRequires:  snmptrapappender
BuildRequires:  xdoclet
BuildRequires:  xerces-j2
BuildRequires:  xjavadoc

Requires:  bsh
Requires:  concurrent
Requires:  dom4j
Requires:  javacc
Requires:  javassist
Requires:  jboss-common-core
Requires:  jboss-common-logging-log4j
Requires:  jboss-common-logging-spi
Requires:  jboss-man
Requires:  jboss-mdr
Requires:  jboss-microcontainer2
Requires:  jboss-reflect
Requires:  jboss-vfs2
Requires:  j2ee_connector_1_5_api
Requires:  log4j
Requires:  servlet_2_5_api
Requires:  snmptrapappender
Requires:  xdoclet
Requires:  xerces-j2
Requires:  xjavadoc

%description
JBoss AOP.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{oname}-%{version}
%patch0 -b .sav0
%patch1 -b .sav1

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/
cp %{SOURCE3} $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/org.jboss-jboss-parent.pom
export MAVEN_OPTS="-Xmx384m"

mvn-jpp -e \
        -s ${M2SETTINGS} \
%if %{with_jrockit}
        -Djrockit.home=%{_jvmdir}/java-1.5.0-oracle \
%endif
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install


mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
%if %{with_jrockit}
        -Djrockit.home=%{_jvmdir}/java-1.5.0-oracle \
%endif
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

#/usr/bin/jboss-aop-annotationc
#/usr/bin/jboss-aop-aopc
#/usr/bin/jboss-aop-aopc15
#/usr/bin/jboss-aop-create-pluggable-jboss-classloader
#/usr/bin/jboss-aop-run-load-boot
#/usr/bin/jboss-aop-run-load-system
#/usr/bin/jboss-aop-run-load15
#/usr/bin/jboss-aop-run-load15HotSwap
#/usr/bin/jboss-aop-run-precompiled
#/usr/bin/jboss-aop-run-precompiled15


# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 aop/target/%{oname}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-%{version}.jar
install -m 644 aop/target/%{oname}-client.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-client-%{version}.jar
install -m 644 aop/target/%{oname}-single.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-single-%{version}.jar
install -m 644 aop/target/%{oname}-tests.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-tests-%{version}.jar
install -m 644 aspects/target/%{oname}-aspects.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{oname}-aspects-%{version}.jar
%if %{with_jrockit}
install -m 644 jrockit-pluggable-instrumentor/target/jrockit-pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jrockit-pluggable-instrumentor-%{version}.jar
%endif
install -m 644 pluggable-instrumentor/target/pluggable-instrumentor.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/pluggable-instrumentor-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}-parent.pom
%add_to_maven_depmap org.jboss.aop %{oname}-parent %{namedversion} JPP/%{name} %{oname}-parent
install -m 644 aop/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}.pom
%add_to_maven_depmap org.jboss.aop %{oname} %{namedversion} JPP/%{name} %{oname}
install -m 644 aspects/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{oname}-aspects.pom
%add_to_maven_depmap org.jboss.aop %{oname}-aspects %{namedversion} JPP/%{name} %{oname}-aspects
install -m 644 jrockit-pluggable-instrumentor/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jrockit-pluggable-instrumentor.pom
%add_to_maven_depmap org.jboss.aop jrockit-pluggable-instrumentor %{namedversion} JPP/%{name} jrockit-pluggable-instrumentor
install -m 644 pluggable-instrumentor/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-pluggable-instrumentor.pom
%add_to_maven_depmap org.jboss.aop pluggable-instrumentor %{namedversion} JPP/%{name} pluggable-instrumentor

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/*
%{_datadir}/maven2/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Mon Jun 08 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.1.1-1
- 2.1.1.GA

